<?lsp

local fmt=string.format
function pfmt(...)
   response:write(fmt(...))
end

local function string2URL(s)
   return string.find(s, "^/") and s:gsub(' ','-') or ("/"..s:gsub(' ','-'))
end

local function parentURL(key)
   return fmt("%s?parent=%s",request:url(),key)
end

local data = request:data()

local env,conn = app.openDb()

if data.up then
   local url
   local parent=tonumber(data.up)
   if parent then
      parent = app.sqlutil.find(conn,fmt("parent FROM links WHERE k=%u",parent))
      if parent and parent ~= "0" then
         url=parentURL(tonumber(parent))
      end
   end
   if not url then
      url=request:url()
   end
   response:sendredirect(url)
   return
end


local editKey=data.edit
local parent

local extrainfo=""
local baseURI
if data.parent and data.parent ~= "0" then
   parent=tonumber(data.parent)
   local lname,url
   if parent then
      lname,url,d,iscat = app.sqlutil.find(conn,fmt("lname,url,data,iscat FROM links WHERE k=%u",parent))
   end
   if iscat ~= "1" then
      app.closeDb(env,conn)
      response:sendredirect(request:url())
      return
   end
   extrainfo=fmt("<h3>Category: %s, base URI: %s</h3>",lname,url)
   baseURI=url
else
   parent=0
   baseURI=""
end


if data.url and request:method() ~= "POST" then
   local rurl
   local key,d,iscat =
      app.sqlutil.find(conn,fmt("k,data,iscat FROM links WHERE URL=%s",
                                env.quotestr(data.url)))
   if key then
      if iscat == "1" then
         rurl=parentURL(key)
      else
         rurl=data.url
      end
   else
      rurl=request:url()
   end
   app.closeDb(env,conn)
   response:sendredirect(rurl)
   return
end

function emitEditPage(key,position,lname,url)
   local extra
   if not key then
      key = "-1"
      position="0"
      lname=""
      url=baseURI
      extra='<input style="width:10px;margin:5px" type="checkbox" name="newcat"/>&nbsp;Create&nbsp;category'
   else
      extra=[[<input type="submit" value="Delete" style="background:red" onclick="return confirmDelete();"/>
            <input type="submit" name="cancel" value="Cancel"/>
             ]];
   end
   pfmt([[
<tr>
<form method="post">
<td><input class="y" type="text" name="position" value="%s"/></td>
<td><input class="y" type="text" name="lname" value="%s"/></td>
<td><input class="y" type="text" id="url" name="url" value="%s"/></td>
<td>
<input type="submit" value="Save" onclick="return checkSave();" />
%s
<input type="hidden" id="deletepage" name="deletepage" value="no"/>
<input type="hidden" name="parent" value="%u"/>
<input type="hidden" name="key" value="%s"/>
</td>
</form>
</tr>
     ]],
  position,
  lname,
  url,
  extra,
  parent,
  key)
end


if request:method() == "POST" then
   if data.cancel then
      editKey=nil
   else
      if data.position and data.lname and #data.lname > 0 and data.url then
         if data.url:find"[&<>]" then
            response:senderror(400,"Invalid URI")
            response:abort()
         end
         data.lname = bd.xssfilter(data.lname)
         if #data.position == 0 or not tonumber(data.position) then data.position="0" end
         if parent ~= 0 then
            local prio = app.sqlutil.find(conn,fmt("position FROM links WHERE k=%d",parent))
            if prio < "0" and data.position >= "0" then
               data.position = "-1"
            end
         end
         if #data.url > 0 then
            if not string.find(data.url, "^http[s]?://") then -- if not absolute URL
               data.url = string2URL(data.url)
            end
         else
            data.url = string2URL(data.lname)
         end
         local sql
         if data.deletepage == "true" then
            conn:setautocommit("IMMEDIATE",1000)
            conn:execute(fmt("DELETE FROM links WHERE k=%s", data.key))
            conn:execute(fmt("DELETE FROM links WHERE parent=%s;", data.key))
            conn:commit()
         elseif data.key == "-1" then
            if data.newcat then
               local path = data.url.."/"
               path=path:gsub("//","/") 
               sql=fmt('%s values(%s,%u,%u,%s,%s,0,"",1)',
                       'INSERT INTO links (position,parent,date,lname,url,lsp,data,iscat)',
                       data.position,
                       parent,
                       os.time(),
                       env.quotestr(data.lname),
                       env.quotestr(path))
            else
               sql=fmt('%s values(%s,%u,%u,%s,%s, "<h1>Fix me</h1>CLick the \'Edit Page\' button",0)',
                       'INSERT INTO links (position,parent,date,lname,url,data,lsp)',
                       data.position,
                       parent,
                       os.time(),
                       env.quotestr(data.lname),
                       env.quotestr(data.url))
            end
            conn:execute(sql, 1000)
         else
            local orglink,d = app.sqlutil.find(conn,fmt("url,data FROM links WHERE k=%s",data.key))
            if orglink then
               conn:setautocommit(false,"IMMEDIATE",1000)
               local newLink=data.url
               if newLink ~= orglink and not d then
                  newLink = data.url.."/"
                  newLink=newLink:gsub("//","/") 
               end
               local ok,err=conn:execute(fmt(
                                'UPDATE links SET position=%s,date=%u,lname=%s,url=%s WHERE k=%s',
                                data.position,
                                os.time(),
                                env.quotestr(data.lname),
                                env.quotestr(newLink),
                                data.key))
               if newLink ~= orglink and not d then
                  orglink = orglink:gsub("[%^%$%(%)%%%.%[%]%*%+%-%?]",function(c) return "%"..c end)
                  local url
                  local function updateLinks(parent)
                     local function action(cur)
                        local k
                        k,url,d = cur:fetch()
                        while k do
                           url=url:gsub(orglink,newLink)
                           ok,err=conn:execute(fmt(
                               'UPDATE links SET url=%s WHERE k=%s',env.quotestr(url),k))
                           if not ok then break end
                           if not d then
                              updateLinks(k)
                              if not ok then break end
                           end
                           k,url,d = cur:fetch()
                        end
                        cur:close()
                     end
                     app.sqlutil.select(conn,fmt('k,url,data FROM links WHERE parent=%s',parent), action)
                  end
                  updateLinks(data.key)
               end
               if ok then
                  conn:commit()
               else
                  conn:rollback() 
               end
            end
         end
         app.closeDb(env,conn)
         app.linksUpdated() -- Update the links in the app table.
         response:sendredirect(parentURL(parent))
         return
      end
   end
end

local cur = conn:execute(
   fmt('%s%u ORDER BY position',
       'SELECT k, position, lname, url FROM links WHERE parent=',
       parent))

-- The extra header we need ".header" to add.
headerdata=fmt('<script type="text/javascript">var baseURI="%s";</script>%s',
baseURI,
[[
<script type="text/javascript" src="configure.js"></script>
<link href="/rtl/fstab.css" rel="stylesheet" type="text/css" />
<style type="text/css">
input:focus, input.focus {
   border-style:inset;
}

input{
  margin:0;
  padding:0;
  width:100%;
}

input.y{
  background:#FFFFA0;
}
</style>
<script type="text/javascript">
function checkSave()
{
   var e = document.getElementById("url");
   var s = e.value;
   if(s.search(new RegExp("^"+baseURI)) < 0 &&
      s.search(new RegExp("^https?://")) < 0) {
      alert("Base URI must start with: "+baseURI);
      return false;
   }
   if(s == baseURI) {
      alert("URI must be base + path");
      return false;
   }
   return true;
};

function confirmDelete()
{
   try {
      var dpe = document.getElementById("deletepage");
      if(dpe) {
         var delPage = confirm("Are you sure that you want to permanently delete the selected page?");
         if(delPage) {
            dpe.value="true";
            return true;
         }
      }
   }
   catch(e) { alert(e); }
   return false;
}

onload = function() {
initHelp("PageManager");
}
</script>
]])
title="CMS: Page Manager"
response:include".header.lsp"

?>

<div id="help"></div>
<img hlp='intro' src='btn/questionmark.32.gif' alt='Help' style='float:right;margin:.5em 3em 0 0;border:none'/>


<h1 style="margin-left:40px">Page Manager</h1>
<?lsp=extrainfo?>
<div style="margin-left:auto;margin-right:auto;width:80%">
<?lsp if data.nomain then ?>
<p style="color:red"><b>Note: </b>You cannot visit the Main Page since you have no page with the URI "/".</p>
<?lsp end ?>
<div id="tab">
<table style="width:100%;border: 1px solid">
<tr><th style="width:30px;">Rank</th><th>Link Name</th><th style="min-width:300px;">URI</th><th>Edit</th></tr>
<?lsp
if data.newpage == "true" then
   emitEditPage()
else
   local key,position,lname,url=cur:fetch()
   while position do
      if editKey == key then
         emitEditPage(key,position,lname,url)
      else
         pfmt(
           [[
<tr><td>%s</td>
<td>%s</td>
<td><a href="?url=%s">%s</a></td>
<td>
<div class="center" style="width:16px">
<a href="%s&edit=%s">
<img src="/images/file.gif" border="0" alt="save"/>
</a>
</div>
</td>
</tr>
          ]],
          position,
          lname,
          url,
          url,
       parentURL(parent),
          key)
      end
      key, position,lname,url=cur:fetch()
   end
end
?>
</table>
</div>
   <input type="submit" value="<?lsp= data.newpage and 'Cancel' or 'Create New Page'?>" style="width:150px;margin:1em;float:right" onclick="window.location='PageManager.lsp<?lsp= data.newpage and fmt('?parent=%u',parent) or fmt('?parent=%u&newpage=true',parent)?>'"/>
   <p><?lsp if parent ~= 0 then print(fmt('<a href="%s?up=%u">up</a>', request:url(),parent)) end ?></p>
</div>
<p><br/></p>

<?lsp 
cur:close()
app.closeDb(env,conn)
response:include".footer.lsp"
?>
