<?lsp

local portMapping = request:data"PortMapping"
if portMapping then
   if portMapping=="yes" then
      response:sendredirect"SearchUPnP.lsp"
   elseif portMapping=="manual" then
      response:sendredirect"PortForward.lsp"
   else
      response:sendredirect"WizEnd.lsp"
   end
   return
end


if not app.upnpdiscover(0) then
   if not app.getPrivateIp() then
      response:sendredirect"WizEnd.lsp"
      return
   end
end
title="Automatic Network Configuration"
-- Make ".header" load our Wikipedia help engine
headerdata=[[
<script src="../help.js"></script>
<script>

function showwait() {
      $("#content").html('<div style="width:180px;margin-left:auto;margin-right:auto;"><img src="/rtl/wfm-album/loading.gif"></div>');
};

$(function(){
   $("#continue").click(function(){
      setTimeout("showwait();", 500);
      return true;
   });
});
</script>

]]
response:include"../wizard/.header.lsp"
?>
<h1><?lsp=title?></h1>

<p>FuguHub can automatically configure "port mapping" in your router using a technology called UPnP. Most modern higher quality routers support this technology.  In addition, FuguHub includes a Dynamic DDNS update client which is required for most broadband users.</p>

<div class="roundedbox bluebox" style="width:80%;margin: auto;">
<p><b style="font-size:120%">Select the first option if you are uncertain.</b></p>

<form method="post">
<ul>
<li>
  <input type="radio" name="PortMapping" value="yes" checked="checked" /> 
  Activate automatic port mapping and optionally enable the DDNS client.
</li>
<li>
  <input type="radio" name="PortMapping" value="manual" /> 
  Manual port mapping, but with instructions and port mapping verification.
</li>
<li>
  <input type="radio" name="PortMapping" value="no" /> 
  I do not need any help, or the server is only used internally on the LAN.
</li>
</ul>
<input type="submit" id="continue" value="Continue" style="width:150px"/>
</form>
</div>
<br/>

<?lsp
showAbort=true
response:include"../wizard/.footer.lsp"
?> 
