<?lsp

local session=request:session()

if request:method() == "POST" then
   local logo,seclogo
   local data=request:data()
   if session.customizeKey == data.key then -- CSRF management
      if data.restoreurl or data.seturl then
         if data.restoreurl then
            logo="/rtl/images/logo.png"
            seclogo="/rtl/images/securelogo.png"
         else
            logo=data.logo
            seclogo=data.seclogo
         end
         bd.setLogoURL(logo,seclogo)
      elseif data.setabout or data.restoreabout then
         bd.setAbout(data.setabout and data.about)
      end
   end
end

local key = string.format("%s%s",ba.rnd(),ba.rnd())
session.customizeKey=key

-- The extra header we need ".header" to add.
headerdata=[[
<link href="style.css" rel="stylesheet" type="text/css" />
<style>
div.panel { width:700px;margin:10px;height:110px;}
div.panel table {width:100%}
#inpfield input {width:600px;}
#cmsdocs {float:right;margin:30px;}
.err {font-weight:bold;color:red}
#about {width:98%;margin:auto}
#about textarea {width:100%}
</style>

<script type="text/javascript">
$(function() {

$("#cmsdocs").click(function(){
   var w = window.open(
      "/rtl/protected/admin/fs/cmsdocs/",
      "cmsdocs",
      "scrollbars=1,toolbar=0,status=0,resizable=1,width=800,height=640");
   if(!w) alert('Your browser is blocking the pop-up window');
   $(this).blur();
   return false;
});

});
</script>
]]
title="Menu: Administrator Panel: Customize Server"
response:include"/rtl/.header.lsp"
?>
<span class="lefthlp">
<a href="#"><img style="float:right;padding-right:20px" src="../../bindows/html/images/questionmark.32.gif" />
<span>
<h3>Customize the two server logos</h3>
<p>You can change the logo shown in the top left corner to your own logo. Two logos are used: one for standard URL's and one for secure HTTPS URL's.</p>
<p>Copy your own logo to the cmsdocs directory and change the URL to your own logo. For example, if you create the sub-directory 'images' in the 'cmsdocs' directory and upload your logo 'my-logo.jpg' to cmsdocs/images/, the URL should be:<br/>/images/my-logo.jpg.</p>
<p>Note: The logo size should preferably be 150 x 80 pixels. The standard and the secure logo may be the same. Customizing the logo requires a business license.</p>

<h3>Customize the About Page</h3>
<p>You can change or completely replace the about page if you know how to write HTML. Customizing the about page requires a business license.</p>
</span>
</a>
</span>
<h1>Customize Server Logo</h1>
<table>
<tr>
<td>
  <form method="post"><div class="panel">
    <p style="text-align:center;margin:0;padding:0;font-weight:bold">Logo URL</p>
    <table id="inpfield">
      <tr><td>Standard:</td><td><input type="text" name="logo" value="<?lsp=bd.logoURL()?>" /></td></tr>
      <tr><td>Secure:</td><td><input type="text" name="seclogo" value="<?lsp=bd.secLogoURL()?>"/></td></tr>
    </table>
    <input type="submit" name="seturl" value="Set Custom URL" />
    <input type="submit" name="restoreurl" value="Restore Default URL" />
    <input type="hidden" name="key" value="<?lsp=key?>" />
  </div></form>
</td>
</tr>
<tr>
<td>
  <div class="panel">
  <table id="logo">
    <tr><th>Standard Logo</th><th>Secure Access Logo</th></tr>
    <tr>
      <td>
        <img src="<?lsp=bd.logoURL()?>" alt="Server Logo" />
      </td>
      <td>
        <img src="<?lsp=bd.secLogoURL()?>" alt="Secure Server Logo" />
      </td>
    </tr>
  </table>
  </div>
</td>
</tr>
</table>

<input id="cmsdocs" type="submit" value="Upload images to cmsdocs" />
<br style="clear:both"/>

<h1>Customize About Page</h1>
<form method="post">
<div id="about">
<textarea rows="25" name="about"><?lsp=bd.getAbout()?></textarea>
</div>
<input type="submit" name="setabout" value="Set Custom About Page" />
<input type="submit" name="restoreabout" value="Restore Default About Page" />
<input type="hidden" name="key" value="<?lsp=key?>" />
</form>

<?lsp response:include".footer.lsp" ?>
