<?lsp

local hasMasterPwd= bd.db.hasMasterPassword()
local err

-- Cache data so it can be used by included pages
local data=bd.rtrim(request:data())
if data.password and data.masterpwd and data.masterpwd2 then
   if data.masterpwd ==  data.masterpwd2 then
      if hasMasterPwd then
         err = (not bd.db.installMasterPassword(data.password, data.masterpwd)) and "Incorrect current master password."
      else
         err = "Incorrect FuguHub password."
         local name = request:user()
         local userdb = bd.db.user.load()
         if userdb and userdb.v and userdb.v[name] then
            local user = userdb.v[name]
            err = user.pwd ~= data.password and err
         end
         if not err then
            if not bd.db.installMasterPassword(nil, data.masterpwd) then
               err="Unable to install master password."
            end
         end
      end
   else
      err="Your new master passwords do not match."
   end
end

hasMasterPwd= bd.db.hasMasterPassword()
local pwdinfo = hasMasterPwd and "Current Master" or "Your FuguHub" 

-- The extra header we need ".header" to add.
headerdata=[[
<link href="style.css" rel="stylesheet" type="text/css" />
<style>
#theform {width:370px;margin-top:30px;margin-left: auto ;margin-right: auto;}
p.err {font-weight:bold; color:red;}
</style>
]]
title="Menu: Master Password"
response:include".header.lsp"
emitHelpBut("masterpwd", true)
?>
<h1>Set <?lsp=hasMasterPwd and "New " or ""?>Master Password</h1>
  <form id="theform" class="roundedbox" method="post">
  <?lsp 
     if err then
        response:write("<p class='err'>",err,"</p>") 
     elseif data.password then
        response:write("<p><b>Master password saved!</b></p>") 
     end
  ?>
  <table style="text-align: right;">
      <tr>
        <td><label><?lsp=pwdinfo?> Password: </label></td><td><input type="password" name="password" autocomplete="off"/></td>
      </tr>
      <tr>
        <td><label><?lsp=hasMasterPwd and "New " or ""?>Master Password: </label></td><td><input type="password" name="masterpwd" autocomplete="off"/></td>
      </tr>
      <tr>
        <td><label>Confirm Master Password: </label></td><td><input type="password" name="masterpwd2" autocomplete="off"/></td>
      </tr>
    <tr>
      <td colspan="2"><input id="changesub" type="submit" value="Change" /></td>

    </tr>
  </table>
 </form> 

<?lsp response:include".footer.lsp" ?>
