<?lsp

local ok=true
local data=request:data()

local email
-- Cache data so it can be used by included pages
if request:method() == "POST" then
   ok=false
   local name = request:user()
   if name then
      email=bd.rtrim(data.email)
      local pwd=bd.rtrim(data.password)
      local userdb = bd.db.user.load()
      if userdb and userdb.v and userdb.v[name] then
         local user = userdb.v[name]
         if user.pwd == pwd and email then
            ok=true
            local db=bd.db.load("emails", true).v
            db[name]=email
            bd.db.save("emails", {v=db})
            if data.lfm then
               response:sendredirect"mail/manage/settings.lsp"
            end
         end
      end
   end
end
email=email or bd.db.email(request,true)

-- The extra header we need ".header" to add.
headerdata=[[
<link href="style.css" rel="stylesheet" type="text/css" />
<style>
p {text-align:center}
input.wide { width:370px; }
#theform {width:450px;margin-top:30px;margin-left: auto ;margin-right: auto ;background:#F0F0F0;padding:6px;border: 2px ridge;border-radius: 10px;box-shadow: 10px 10px 5px #888;}
</style>
<script type="text/javascript" src="../jquery.js"></script>
<script type="text/javascript">
$(function() {
        var reg=/^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.([a-z][a-z]+)|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i;
   $('#savebut').click(function() {
      var inp=$('input[name=email]');
      var e=$.trim(inp.val());
      var x=/<([^<>]+)>$/.exec(e);
      if( ! reg.test(x && x[1] ? x[1] : e) ) {
         alert('Please provide a valid email address!');
         $(this).blur();
         return false;
      }
      inp.val(e);
   });
});
</script>
]]

local saved = ok and request:method()=="POST"
 
title="Menu: Email Address"
response:include"/rtl/.header.lsp"
?>
<h1>Email Address</h1>
<p>
<?lsp if data.lfm then ?>
  The Large File Mailer requires that you set your "from" email address.<br/>Enter your email address and your FuguHub login password.
<?lsp else ?>
  Save your email address to enable password recovery and/or enable sending emails.
<?lsp end ?>
</p>
    <form id="theform" method="post">
  <table style="text-align: right;">
      <tr>
        <td>Email: </td><td><input class="wide" type="text" name="email" value="<?lsp=email?>" placeholder="firstname lastname <name@domain.xx>"/></td>
      </tr>
      <tr>
        <td>Password: </td><td><input class="wide" type="password" name="password" placeholder="<?lsp=saved and '' or 'Enter your password'?>" autocomplete="off"/></td>
      </tr>
    <tr>
      <td colspan="2"><input id="savebut" type="submit" value="Save" /></td>
    </tr>
  </table>
 </form>
<br/>
<?lsp if not ok then ?>
<p style="font-weight:bold;color:red">Invalid password!</p>
<?lsp elseif saved then ?>
<p style="font-weight:bold">Email address saved!</p>
<?lsp end ?>
<?lsp response:include".footer.lsp" ?>
