<?lsp
headerdata=[[
<style>{color:blue;text-decoration:underline}</style>
]]
if not title then
   title="Menu: Mail Manager: Help"
end
response:include"/rtl/.header.lsp"

if empty then
   _emit'<p style="padding: 0 2em 0 2em;border: 1px solid red"><b><br/>You see the "Mail List Manager Introduction" since your master contact list is emtpy or you do not have any lists. See the <a href="#smtp">Getting Started Guide</a> for how to configure the Large File Mailer.</b><br/>'
end
?>

<h1>Mail List Manager: Introduction</h1>

<p>The Mail List Manager manages the contacts and mail jobs for the Web File Manager's integrated Large File Mailer. See the <a href="../help.lsp?admin=">Large File Mailer Introduction</a> for more information</p>

<?lsp response:include"../manage/help-intro.shtml" ?>

<a name="emarketing"></a>
<h2>Email Marketing and CAN-SPAM Compliance!</h2>

<p>The Large File Mailer is primarily designed for sending files to individuals or to contacts in one or several lists via the Web File Manager. However, you can also use the Large File Mailer for email marketing purposes by sending emails to one or several lists. See our <a target="_blank" href="https://FuguHub.com/blog/2013/02/EMail-Marketing-with-FuguHub">E-Mail Marketing with FuguHub tutorial</a> for more information on E-Mail marketing.</p>

<p>The [LINK] macro is required for CAN-SPAM Compliance when using the <a href="send.lsp">Send Email</a> feature. The [LINK] macro will expand to a URL where the recipient(s) can either unsubscribe or update/modify the first and last name. When a recipient unsubscribes, the contact is permanently deleted from the contact database.</p>

<p>The [LINK] macro serves a different purpose in the Large File Mailer, which is started from the Web File Manager. The [LINK] macro expands to one or several "download file" links when used by the Large File Mailer and the recipients can for this reason not be provided with a link where they can unsubscribe when sending emails via the Large File Mailer.</p>


<a name="smtp"></a>
<h2>Getting Started</h2>
<h3>Settings</h3>
<p>Start by configuring the <a href="settings.lsp">SMTP settings</a>. The SMTP settings are usually provided by your Internet Service Provider (ISP). A suggestion is to copy the settings from your standard email program.</p>
<p>You must also provide a domain name for your FuguHub server. A domain name is required since the automatically created links (expanded by macro [LINK]) require your server's domain name.</p>
<p>The send delay is in seconds and is the time the email engine waits in between sending emails. This time defaults to 60 seconds unless changed. You may have to increase this time if you are using a residential ISP since the ISP typically limits the number of emails you are allowed to send.</p>

<h3>Lists</h3>

<p><a href="list.lsp">Create a list</a> and import your email contacts from your existing mail program or from online providers such as Gmail and Hotmail. The file you import must be a Comma Separated Value (CSV) file. Most email programs, including online email providers, can export contacts as a CSV file. We suggest that you open the exported file in for example, Microsoft Excel, prior to importing the contacts. Some email programs error when exporting and you may have to correct the file before importing. Import a CSV file by clicking the upload button or by dragging and dropping the CSV file into the browser.</p>
<ul style="list-style-type:none">
<li><img src="../../../images/dropbox64.png" style="display:inline;" /> The upload button.</li>
<li><img src="../img/upload.png" style="display:inline;" /> You do not see this icon unless your browser supports drag and drop upload.</li>
</ul>

<h4>Tip: Convert a vCard file to a CSV file</h4>
<p>The Mail List Manager accepts CSV files for importing contacts. Unfortunately, some address books such as the Mac Address Book does not export directly to CSV, but to the vCard format.</p>
<p>A simple solution to circumvent this problem is to import the vCard file into a Gmail account and then export the address book as a CSV file, which can then be imported by the Mail List Manager.</p>
<p>See the <a href="http://mail.google.com/support/bin/answer.py?hl=en&answer=183711">Gmail vCard import help</a> for more information.</p>

<a name="password"></a>
<h3>Confirmed email address</h3>
<p>If you require that contacts provide a password, click the "Contact confirmation request" <img src="../img/mail-pwd.png" style="display:inline;" /> button and send the contacts an email requesting them to confirm their email address and set a password.</p>

<?lsp response:include"../manage/help-send.shtml" ?>

<p>Email jobs created by using the File Mailer wizard in the Web File Manager are automatically appended to the <a href="jobq.lsp">job queue</a>. The email engine, which runs in the background, is responsible for sending out the emails. Sending emails may take considerable time. The email engine will automatically resume jobs if you restart the server. The only way to stop a job is to terminate the job by using the <a href="jobq.lsp">job queue manager</a>.</p>

<p>A residential Internet Service Provider's SMTP server may limit the number of emails one can send within a certain time frame and will prevent the email engine from sending further emails when the limit is reached. On errors, the email engine recalculates the time between sending emails. The time keeps increasing by a factor of two for each failed send attempt. The time is automatically reset when sending the email succeeds.</p>

<h2>HTML Emails</h2>

<p>Standard text typed into the email body text area is sent as a text email. However, the email engine can also send HTML (rich text) emails. HTML emails must be created using an external tool and packaged as an EML (Email Markup Language) or MHT/MHTML (MIME HTML) file. These files can be created by tools that encapsulate all content into one file.</p>

<b>Send HTML emails as follows:</b>
<ol>
<li>Use an external EML rich text tool, such as <a href="http://www.sendblaster.com/" target="_blank">SendBlaster free edition</a>, to create the HTML email.</li>
<li>Save the file as an EML file</li>
<li>Use an editor such as notepad and open the EML file</li>
<li>Copy all content in the editor</li>
<li>Paste the content into the FuguHub email body text area</li>
</ol>


<h2>Batch Jobs</h2>
<p>A batch job is an external command that can be attached to a mail job. The external batch job is executed by FuguHub when a contact clicks on a link that is originating from a mail job attached to a batch job.</p>
<p>Batch jobs are for advanced users with a good understanding of command line programs and command line scripts.</p>
<p>Batch jobs make it possible to customize file downloads for each contact in the database. Batch jobs may, for example, be used by software vendors to distribute software to their customers when they require a customized file for each contact in the database.</p>
<p>See the <a href="batchjob.lsp">batch job readme file</a> for more information on how to enable and use batch jobs.</p>

<?lsp response:include".footer.lsp" ?>
