<?lsp

local function w(...) response:write(...) end
local data=bd.rtrim(request:data())
local s=request:session()
local email=s.xemail
local emsg=""
title="Menu: Mail Manager: Send Email"

local ispost = request:method() == "POST"

if email and ispost then
   local list={}
   local data = {}
   local tinsert=table.insert
   local err
   request:multipart({
         error=function(e) err=e end,
         formdata=function(k,v) 
                     if k == "list" then
                        tinsert(list,v)
                     else
                        data[k]=v
                     end
                  end
      })
   if err then print(err) return end
   email.body=data.body or email.body
   email.subject=data.subject or email.subject
   email.fromaddr=data.fromaddr or email.fromaddr
   if #list > 0 then
      email.list=list
      if data.body and data.fromaddr then
         local function x(x) return x end
         local mailutil=require"mailutil"
         local body,foundT=mailutil.expandmacros(data.body, {LINK=x}) 
         if foundT.LINK then
            mailutil.startjob(email.fromaddr,email)
            ba.sleep(3000)
            response:sendredirect"jobq.lsp"
         end
         emsg="<p class='err'>Macro <a href='help.lsp#macros'>[LINK]</a> required for CAN-SPAM Compliance!</p>"
      end
   end
end

local env,conn = bd.openDb"bd"
local sqlutil=require"sqlutil"
local quote=luasql.quotestr
local fmt=string.format

if not email then
   response:include"../../../.smtp.lsp"
   local dn=require"mailutil".settings(conn,"domainname")
   if not dn or #dn == 0 or not loadSmtpFromBdDb() then
      response:include"/rtl/.header.lsp"
      w'<p>You must <a href="help.lsp#smtp">configure SMTP</a> before you can send emails.</p>'
      response:include".footer.lsp"
      bd.closeDb(env,conn)
      return
   end

   email={solicit=true,fromaddr=bd.db.email(request,true),io="void",
      defsub="Newsletter",files={},settings={attach=true}}
   email.body="Hello [FIRSTNAME]\n\nClick the following link to unsubscribe or update your profile:\n[LINK]\n"
   s.xemail=email
end

if not ispost and data.jobkey and tonumber(data.jobkey) then
   local fromaddr,subject,txtbody,listkey=sqlutil.find(
      conn,"fromaddr,subject,txtbody,listkey FROM mailjob where key="..data.jobkey)
   if fromaddr and subject and txtbody and listkey then
      local list=ba.json.decode(listkey)
      if list then
         email.fromaddr,email.subject,email.body,email.list = fromaddr,subject,txtbody,list
      end
   end
end


local function listjobs(cur)
   local key,subject,date = cur:fetch()
   if key then
      w'<table><tr><td>History: </td><td><select id="history">'
      if not data.jobkey then w'<option value="0" selected="selected">Select Optional History</option>' end
      while key do
         if #subject > 93 then subject=subject:sub(1,90).."..." end
         w('<option ',data.jobkey==key and 'selected="selected" ' or '','value="',key,'">',date,': ',subject,'</option>')
         key,subject,date = cur:fetch()
      end
      w'</select></td></tr></table>'
   end
end

local function tzone()
   local tzone=request:cookie"tzone"
   if tzone then
      tzone = tonumber(tzone:value())
      if tzone then return fmt("%d",tzone*60) end
   end
   return ""
end

function emitHistory(conn)
   sqlutil.select(conn,fmt("key,subject,date(date%s,'unixepoch') %s",
                           tzone(),"FROM mailjob WHERE attach=='solicit' ORDER BY date DESC LIMIT 15"), listjobs)
end


headerdata=[[
<style>
input.error {border: 1px solid red;color:red;background:yellow}
#history{min-width:695px;margin-left:10px}
#pad {padding:0 5px 0 5px;}
textarea {width:100%;height:320px;}
#subject{width:100%;border-collapse:collapse}
input[type=submit] { min-width:100px;height:30px;}
#selaction {display:none}
p.err{font-weight:bold;color:red}
#contactscont {text-align:left;margin-top:0}
#list table a {text-decoration:none;position:relative}
#list table a span {display:none;}
#list table a:hover span {
  display:block;
  min-width:300px;
  position:absolute;
  z-index: 999;
  top:-30px;
  left:100px;
  background: white;
  color:black;
  padding: 10px;
  border-radius: 5px;
  border: 1px solid black;
  box-shadow: black 5px 5px 5px 0px;
}
</style>
<script type='text/javascript'>
$(function() {
   $("#history").change(function() {
      window.location = window.location.pathname+"?jobkey="+$(this).val();
   });

   var reg=/^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.([a-z][a-z]+)|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i;

   function valEmail(inp) {
      var e=$.trim(inp.val());
      var x=/<([^<>]+)>/.exec(e);
      if(reg.test(x && x[1] ? x[1] : e)) {
         inp.val(e);
         return true;
      }
      return false;
   };
   
   $("#sendbut").click(function() {
       if( ! valEmail($('#fromaddr')) ) {
          $('#fromaddr').addClass("error").keydown(function() {
             $(this).removeClass("error"); 
          });
          return false;
       }
       return true;
   });
 
   function  updConts(isDisabled) {
      $("#contactscont").css("color","blue");
      setTimeout('$("#contactscont").css("color","");', 1500);
      if(isDisabled)
         $("#sendbut").attr("disabled","disabled");
      else
         $("#sendbut").removeAttr("disabled");
   };

   function updateSelCont(){
      var checked=$("#list :checked");
      var isDisabled=false;
      if(checked.length > 0) {
         var url="../countcontacts.lsp?type=list";
         checked.each(function(x) {
            url+="&k="+$(this).val();
         });
         $.getJSON(url, function(resp) {
            $("#contacts").html(resp.length > 0 ? resp.length+"" : "list empty!");
            isDisabled = resp.length == 0;
            updConts(isDisabled);
         });
      }
      else {
         $("#contacts").html("0");
         isDisabled=true;
         updConts(isDisabled);
      }
   } 
   $("#list input").click(updateSelCont);
   updateSelCont();
});
</script>
]]
response:include"/rtl/.header.lsp"
?>
<div class="roundedbox">
<?lsp emitHistory(conn) ?>
<form method="post" enctype="multipart/form-data">
<div id="list">
<fieldset><legend>Lists:</legend>
<?lsp 
  if io:dofile".bdlua/emitmlists.lua"(w,sqlutil,conn,email) == 0 then
?>
  <p>Database empty!</p><p><a href="list.lsp">Create a new list</a>.</p>
<?lsp end ?>
</fieldset>
<h3 id="contactscont">Selected Recipients: <span id="contacts">0</span></h3>
</div>
<div id="pad">
<table id="subject">
<tr>
<td style="width:55px;">From: </td>
<td><input style="width:100%" type="text" id="fromaddr" name="fromaddr" value="<?lsp=email.fromaddr?>" placeholder="From Name <from@addr.com>"/></td>
</tr>
<tr>
<td>Subject: </td>
<td><input style="width:100%" type="text" id="subject" name="subject" value="<?lsp=email.subject or ""?>" placeholder="Newsletter"/></td>
</tr>
</table>
<?lsp=emsg?>
<textarea name="body"><?lsp=email.body?></textarea>
<a href="help.lsp#emarketing" style="float:right;margin:8px 15px 0 0"><img  src="/rtl/bindows/html/images/questionmark.16.gif"></a>
<input id="sendbut" disabled="disabled" type="submit" name="send" value="Send Email"/>
</div>
</form>
</div> 
<?lsp
bd.closeDb(env,conn)
response:include".footer.lsp"
?>
