<?lsp

data=request:data()
response:include".jobhistory.lsp"
headerdata=headerdata..[[
<script type='text/javascript' src='prepare.js'></script>
<script type='text/javascript'>$(prepare);</script>
]]
response:include".header.lsp"

local sqlutil=require"sqlutil"
local env,conn=bd.openDb"bd" 
local function w(...) response:write(...) end
local settings

local function emitCheckbox(name, isChecked)
   w('<input type="checkbox" name="',name,'" id="',name,'"',
     isChecked and " checked" or "",'/>')
end

local function getChecked(attr, val)
   if attr == val then
      return ' checked="checked"'
   end
   return ""
end

local function emitRadio(group, val, attr)
   w('<input type="radio" name="',group,'" value="',
     val ,'"', getChecked(attr,val),'/>')
end

local function emitOptionVal(val,attr,info)
   w('<option value="',val,'"',val==attr and ' selected="selected"' or '','>',info,'</option>')
end

local function emitIndividualTr(v,attr)
   w'<tr><td><select name="to">'
   emitOptionVal("to",attr,"To")
   emitOptionVal("cc",attr,"Cc")
   emitOptionVal("bcc",attr,"Bcc")
   w('</select></td><td><input type="text" name="recipient" value="',v,'" autocomplete="off" /></td></tr>')
end

local function emitIndividual()
   if email.individual then
      local e=email.individual
      local x={{attr="to",list=e.to},{attr="cc",list=e.cc},{attr="bcc",list=e.bcc}}
      for _,l in ipairs(x) do
         for _,v in ipairs(l.list) do
            emitIndividualTr(v, l.attr)
         end
      end
   else
      emitIndividualTr("","to")
   end
end


local function batchAction(cur)
   local key,name = cur:fetch()
   if name then
      local batchkey=settings.batchkey
      w('<p></p><fieldset id="batch"><legend>Batch Job</legend><select name="batchkey">')
      emitOptionVal('','none','-- No Batch Job --')
      while name do
         emitOptionVal(key,batchkey,name)
         key,name = cur:fetch()
      end
      w'</select></fieldset>'
   end
end

local function emitBatch()
   if bd.mailbatchauth:authorize(request,"GET","") then
      sqlutil.select(conn,'key,name FROM mailbatchjob', batchAction)
   end
end

if data.jobkey and tonumber(data.jobkey) then
   local tokey,listkey,groupkey,attach,secure,password,expires,batchkey=sqlutil.find(
      conn,
      "tokey,listkey,groupkey,attach,secure,password,expires,batchkey FROM mailjob where key="..data.jobkey)
   if listkey then
      listkey=ba.json.decode(listkey)
      if tokey then
         email.individual={to=ba.json.decode(tokey),cc=listkey,bcc=ba.json.decode(groupkey)}
         email.list=nil
      else
         email.list=listkey
         email.individual=nil
      end
      email.settings={attach=attach and true,ssl=secure=="1", pwd=password=="1",exptime=expires~="0" and tonumber(expires),batchkey=batchkey}
   end
end

settings=email.settings or {}
emitHistory(conn)
?>
<div id="nav">
<?lsp emitRadio("type","list",email.individual and "" or "list") ?> Send to list(s)
<?lsp emitRadio("type","user",email.individual and "user" or "") ?> Send to individual(s)
</div>
<form method="post" action="prepare-save.lsp">
<div id="spacer">
<div id="list">
<fieldset><legend>Lists:</legend>
<?lsp 
  if io:dofile".bdlua/emitmlists.lua"(w,sqlutil,conn,email) == 0 then
?>
  <p>Database empty!</p><p><a href="../manage/list.lsp" target="_blank">Create a new list</a>.</p>
<?lsp end ?>
</fieldset>
<br/><h3 id="contactscont">Selected Recipients: <span id="contacts">0</span></h3>
</div>
<div id="individualdiv"><table id="individual"><?lsp emitIndividual() ?></table></div>
<p></p>
<fieldset><legend>Settings:</legend>
<div id="attach">
<table><tr>
<td><?lsp emitRadio("attach","no",settings.attach and "" or "no") ?>Send as Link(s)</td>
<td><?lsp emitRadio("attach","yes",settings.attach and "yes" or "") ?> Send as Attachment(s)</td>
<td><div id="attachsize"></div></td>
</tr></table>
</div>
<table id="settings">
<tr id="seccon"><td>Secure Connection Required:</td><td><?lsp emitCheckbox("ssl",settings.ssl) ?></td></tr>
<tr id="pwdtr"><td>Password Required:</td><td><?lsp emitCheckbox("pwd",settings.pwd) ?></td></tr>
<tr>
  <td>Link Expiration Time:</td>
  <td><input type="text" id="exptime" name="exptime" value="<?lsp=settings.exptime and os.date('%Y %B %d, %H:%M',settings.exptime) or ''?>" placeholder="Enter a date. Default is to never expire." autocomplete="off" /></td>
</tr>
<tr><td></td><td id="exptimeinfo"></td></tr>
</table>
</fieldset>
<?lsp emitBatch() ?>
</div>
<input id="sublist" disabled="disabled" type="submit" name="sublist" value="Continue" />
<input id="subindividual" type="submit" name="subindividual" value="Continue" />
</form>



</body>
</html>
<?lsp bd.closeDb(env,conn) ?>
