<?lsp

local io = bd.baseio

for k,v in pairs(data) do
   data[k]=v:gsub("^%s*(.-)%s*$", "%1")
end


-- Create the admin user from information in the 'data' object.
local admin={
   pwd=data.password,
   maxUsers=15,
   recycle=true,
   inactive=1200,
   roles={},
   t=os.time(),
   info=[[
A super-user, created
by the installation wizard.

Notice that the "Roles"
list is empty, which
implies that the
user is in all roles.

The burning flame
indicates that this
is a super-user.
]],
name=data.user}
local udb = {v={}}
udb.v[data.user] = admin -- Save in user database

if data.email then
   local db=bd.db.load("emails", true).v
   db[data.user]=data.email
   bd.db.save("emails", {v=db}) 
   if data.recoverpassword then
      local cfg=bd.cfg.load()
      local smtp=cfg.v.smtp
      if not smtp then
         smtp={
            email="",
            server="",
            port=25,
            uname="",
            password="",
            accounttype="generic",
            consec="none",
            recoverpassword=true,
         }
      end
      cfg.v.smtp=smtp
      bd.cfg.save(cfg)
   end
   local http=require"http".create()
   http:request{
      url="https://FuguHub.com/reg.lsp",
      method="POST",
      shark=bd.getDefaultSharkClient(),
      query={email=data.email}
   }
   http:close()
end

local ok,error =  bd.db.user.save(udb)
if not error then
   local cdb = {v={}}
   -- Create a constraint called admin with access to everything.
   cdb.v.admin={
      urls={"/*"},
      methods={"GET","POST","PUT","PROPFIND","PROPPATCH",
         "MKCOL","DELETE","MOVE","COPY"},
      roles={"admin"}}
   ok,error = bd.db.drvcnstr.save(cdb)
end

title = error and error or "Administrator Account Saved"


-- Make ".header" load our Wikipedia help engine and attempt
-- to auto login the user.

local hd1=[[
<script src="../help.js"></script>
  <script src="/rtl/eh/ODB.js"></script>
  <script src="/rtl/eh/eh.js"></script> 
  <script>
function login(user, password)
{
   try {
      var x = new XMLHttpRequestWrapper();
      x.open("HEAD", "/rtl/protected/", false,user, password);
      x.setRequestHeader("PrefAuth","digest");
      x.send();
   }
   catch(e) {
   }
};
]]

local hd2 = string.format("onload = function() {login('%s','%s');}</script>",
                          data.user,data.password)

-- Assemble the 'headerdata' used by '.header'
headerdata = hd1..hd2



response:include".header.lsp"
print("<h1>",title,"</h1>")
if error then
?>
<p>Please report the error to Real Time Logic.</p>

<?lsp else ?>

<p>You have successfully set the administrator account.</p>
<p style="color:red">
<?lsp if data.recoverpassword then ?>
<b>Notice:</b> You have enabled password recovery for your username, but the password recovery engine is not enabled. The password recovery engine can be activated by configuring the mail server (SMTP) settings in the administrator panel. You can enable SMTP after you have completed this configuration wizard.
<?lsp else ?>
Again, note that it is important that you remember your administrator username and password.
<?lsp end ?>
</p>


<?lsp 
   local s = request:session(true)
    s.username=data.user
    s.password=data.password

   local tcdb = bd.db.tuncnstr.load()
   if tcdb and not tcdb.v.TunFullAcc then -- If no TunFullAcc constraint
      local constr = {urls={"/*"},methods={"GET"},roles={"TunFullAcc"}}
      tcdb.v.TunFullAcc=constr
      bd.db.tuncnstr.save(tcdb)
   end 
   bd.db.roles.add("TunFullAcc",'Users in the "TunFullAcc" role have full access to the HTTPS tunnel server.')
end
?>
<p><br/></p>
<p style="float:right;margin-right:2em"><a href="../intro/" title="Next"><img src="../images/next.png" border="0" /></a></p>
<p><br/></p>
<?lsp response:include".footer.lsp" ?>
