<?lsp
-- Called from JavaScript code in zzPreview.js.
-- Load a preview of blog with blog id (bid).
local date,data
local bid = request:data"bid"
if bid then
   local env,conn = app.openDb()
   if env then
      local cur = conn:execute(string.format("SELECT date,data FROM blog WHERE ROWID = %s", bid))
      if cur then
         date,data = cur:fetch()
         cur:close()
      end
      app.closeDb(env,conn)
      if data then
          -- Remove default LSP headers such as Cache-Control,etc.
         response:reset()
         if request:checktime(date) then
            local ae = request:header("Accept-Encoding")
            response:setcontenttype"text/plain"
            if ae and ae:find("deflate") then
               response:setheader("Vary","Accept-Encoding")
               response:setheader("Content-Encoding", "deflate")
               data=ba.deflate(data)
            end
            response:setcontentlength(#data)
            response:send(data)
         end
         return
      end
   end
end
response:senderror(404)
?>
